KaraokeGui.Helpers = KaraokeGui.Helpers or {}
KaraokeGui.Helpers.DebugTime = KaraokeGui.Helpers.DebugTime or class(ExtendedPanel)

local DebugTime = KaraokeGui.Helpers.DebugTime

function DebugTime:init(parent, config)
	DebugTime.super.init(self, parent, config)

	self._track = config.track

	self._text = self._panel:text({
		x = 0,
		y = 0,
		word_wrap = true,
		wrap = true,
		align = "middle",
		vertical = "top",
		valign = "top",
		layer = 100,
		font = tweak_data.menu.pd2_medium_font,
		font_size = config.size or tweak_data.menu.pd2_medium_font_size
	})

	self:set_text(config.text or "0")
end

function DebugTime:set_text(text)
	self._text:set_text(text)

	local _, _, text_width, text_height = self._text:text_rect()
	self._panel:set_size(text_width, text_height)
end

function DebugTime:check()
	if not self._track then return end

	if not self._track._panel or not alive(self._track) or not self._track:visible() then
		self:remove_self()
	end
end