KaraokeGui.Helpers = KaraokeGui.Helpers or {}
KaraokeGui.Helpers.TimerBar = KaraokeGui.Helpers.TimerBar or class(ExtendedPanel)

local TimerBar = KaraokeGui.Helpers.TimerBar

function TimerBar:init(parent, config)
	TimerBar.super.init(self, parent, config)

	self._background_bar = self:_create_bar("white", self._panel:layer() + 1)
	self._fill_bar = self:_create_bar(config.bar_color or "blue", self._panel:layer() + 2)

	self._background_bar:set_alpha(0.1)

	self:set_fill(0)
end

function TimerBar:_create_bar(color, layer)
	local bar_texture_color_offsets = {
		white = 0,
		green = 27,
		pink  = 54,
		blue  = 81
	}
	local bar_texture_color_offset = bar_texture_color_offsets[color]

	return KaraokeGui.Helpers.GenericBar:new(self._panel, {
		start_texture_rect = { 158 + bar_texture_color_offset, 8, 6, 11 },
		middle_texture_rect = { 169 + bar_texture_color_offset, 8, 11, 11 },
		end_texture_rect = { 163 + bar_texture_color_offset, 8, -6, 11 },
		layer = layer
	})
end

function TimerBar:set_fill(fill_percentage)
	self._fill_percentage = fill_percentage
	self._fill_bar:set_width(self._panel:width() * fill_percentage)
end

local size_update_methods = {
	"set_width",
	"set_shape",
	"set_height",
	"grow",
	"set_size"
}
for _, size_update_method_name in pairs(size_update_methods) do
	TimerBar[size_update_method_name] = function(self, ...)
		self._panel[size_update_method_name](self._panel, ...)

		self._background_bar:set_size(self._panel:width(), self._panel:height())
		self._fill_bar:set_size(self._panel:width(), self._panel:height())

		self:set_fill(self._fill_percentage)
	end
end