KaraokeGui.Helpers = KaraokeGui.Helpers or {}
KaraokeGui.Helpers.TimerBarHoldRapid = KaraokeGui.Helpers.TimerBarHoldRapid or class(ExtendedPanel)

local TimerBarHoldRapid = KaraokeGui.Helpers.TimerBarHoldRapid

function TimerBarHoldRapid:init(parent, config)
	TimerBarHoldRapid.super.init(self, parent, config)

	local offsets = {
		hold = 0,
		rapid_press = 40
	}
	local offset = offsets[config.type or "hold"]

	self._bar = KaraokeGui.Helpers.GenericBar:new(self._panel, {
		start_texture_rect = { 136, 246 + offset, 18, 36 },
		middle_texture_rect = { 154, 246 + offset, 34, 36 },
		end_texture_rect = { 188, 246 + offset, 18, 36 },
		layer = self._panel:layer() + 1
	})

	self._bar_icon = self._panel:bitmap({
		x = 0,
		y = 0,
		texture = "guis/karaoke/game_ui",
		texture_rect = { 9, 247 + offset, 115, 34 },
		layer = self._panel:layer() + 2,
		alpha = 0.85
	})

	self:_update_size_pos()
end

function TimerBarHoldRapid:_update_size_pos()
	self._bar:set_size(self._panel:width(), self._panel:height() / 2)
	self._bar:set_top(self._panel:height() / 4)

	self._bar_icon:set_size(self._panel:height() * 0.9 * 115/34, self._panel:height() * 0.9)
	self._bar_icon:set_center(self._bar:center_x(), self._bar:center_y())
end

function TimerBarHoldRapid:hit()
end

local size_update_methods = {
	"set_width",
	"set_shape",
	"set_height",
	"grow",
	"set_size"
}
for _, size_update_method_name in pairs(size_update_methods) do
	TimerBarHoldRapid[size_update_method_name] = function(self, ...)
		self._panel[size_update_method_name](self._panel, ...)

		self:_update_size_pos()
	end
end