KaraokeGui.Helpers = KaraokeGui.Helpers or {}
KaraokeGui.Helpers.TimerBarLyric = KaraokeGui.Helpers.TimerBarLyric or class(ExtendedPanel)

local TimerBarLyric = KaraokeGui.Helpers.TimerBarLyric

function TimerBarLyric:init(parent, config)
	TimerBarLyric.super.init(self, parent, config)

	self._background = self._panel:bitmap({
		x = 0,
		y = 0,
		w = self._panel:width(),
		h = self._panel:height(),
		layer = self._panel:layer() + 1
	})

	self._fill_panel = self._panel:panel({
		x = 0,
		y = 0,
		w = self._panel:width(),
		h = self._panel:height(),
		layer = self._panel:layer() + 2
	})

	self._fill = self._fill_panel:bitmap({
		x = 0,
		y = 0,
		w = self._panel:width(),
		h = self._panel:height(),
		color = Color(255, 33, 27, 249) / 255
	})

	self._lyric_width = 0
	self:set_fill(0)
end

function TimerBarLyric:set_lyric_texture(texture, lyric_width)
	self._lyric_width = lyric_width

	self._background:set_image(texture)
	self._fill:set_image(texture)

	self:set_fill(self._fill_percentage)
end

function TimerBarLyric:set_fill(fill_percentage)
	self._fill_percentage = fill_percentage
	self._fill_panel:set_width(self._panel:width() * fill_percentage * self._lyric_width)
end

local size_update_methods = {
	"set_width",
	"set_shape",
	"set_height",
	"grow",
	"set_size"
}
for _, size_update_method_name in pairs(size_update_methods) do
	TimerBarLyric[size_update_method_name] = function(self, ...)
		self._panel[size_update_method_name](self._panel, ...)

		self._background:set_size(self._panel:width(), self._panel:height())
		self._fill_panel:set_size(self._panel:width(), self._panel:height())
		self._fill:set_size(self._panel:width(), self._panel:height())

		self:set_fill(self._fill_percentage)
	end
end