KaraokeGui.Helpers = KaraokeGui.Helpers or {}
KaraokeGui.Helpers.TimerBarMarker = KaraokeGui.Helpers.TimerBarMarker or class(ExtendedPanel)

local TimerBarMarker = KaraokeGui.Helpers.TimerBarMarker

function TimerBarMarker:init(parent, config)
	TimerBarMarker.super.init(self, parent, config)

	local marker_bar_colors = {
		blue  = Color(255, 132, 255, 255) / 255,
		pink  = Color(255, 255, 130, 255) / 255,
		green = Color(255, 165, 255, 148) / 255
	}

	self._marker_bar = KaraokeGui.Helpers.GenericBar:new(self._panel, {
		vertical = true,
		start_texture_rect = { 155, 373, 25, 12 },
		middle_texture_rect = { 155, 385, 25, 20 },
		end_texture_rect = { 155, 405, 25, 12 },
		color = marker_bar_colors[config.color or "blue"],
		layer = self._panel:layer() + 1
	})

	local marker_bg_texture_color_offsets = {
		blue  = 0,
		pink  = 42,
		green = 85
	}
	local marker_bg_texture_color_offset = marker_bg_texture_color_offsets[config.color or "blue"]

	self._marker_bg = self._panel:bitmap({
		texture = "guis/karaoke/game_ui",
		texture_rect = { 262, 242 + marker_bg_texture_color_offset, 40, 40 },
		layer = self._panel:layer() + 2
	})

	local marker_texture_color_offsets = {
		blue  = 0,
		pink  = 43,
		green = 86
	}
	local marker_texture_color_offset = marker_texture_color_offsets[config.color or "blue"]

	self._marker = self._panel:bitmap({
		texture = "guis/karaoke/game_ui",
		texture_rect = { 228, 245 + marker_texture_color_offset, 32, 32 },
		layer = self._panel:layer() + 3
	})

	self:_update_size_pos()
end

function TimerBarMarker:_update_size_pos()
	self._marker_bg:set_size(self._panel:width(), self._panel:width())
	self._marker_bg:set_bottom(self._panel:height())

	self._marker_bar:set_size(self._panel:width() * 25/40, self._panel:height())
	self._marker_bar:set_center_x(self._marker_bg:center_x())

	self._marker:set_size(self._panel:width() * 32/40, self._panel:width() * 32/40)
	self._marker:set_center(self._marker_bg:center_x(), self._marker_bg:center_y())
end

local size_update_methods = {
	"set_width",
	"set_shape",
	"set_height",
	"grow",
	"set_size"
}
for _, size_update_method_name in pairs(size_update_methods) do
	TimerBarMarker[size_update_method_name] = function(self, ...)
		self._panel[size_update_method_name](self._panel, ...)

		self:_update_size_pos()
	end
end