KaraokeGui.Helpers = KaraokeGui.Helpers or {}
KaraokeGui.Helpers.TimerBarNote = KaraokeGui.Helpers.TimerBarNote or class(ExtendedPanel)

local TimerBarNote = KaraokeGui.Helpers.TimerBarNote

function TimerBarNote:init(parent, config)
	TimerBarNote.super.init(self, parent, config)

	local button_offsets = {
		circle = 0,
		cross = 64,
		square = 128,
		triangle = 192
	}
	local button_offset = button_offsets[config.button or "circle"]


	local platform_offsets = {
		ps = 0,
		xbox = 64,
		pc = 192
	}
	local platform_offset = platform_offsets[config.platform or "ps"]

	self._button = self._panel:bitmap({
		texture = "guis/karaoke/game_buttons",
		texture_rect = { button_offset, platform_offset, 64, 64 },
		layer = self._panel:layer() + 1
	})

	self._mic = self._panel:bitmap({
		texture = "guis/karaoke/game_ui",
		texture_rect = { 581, 6, 49, 107 },
		layer = self._panel:layer() + 1,
		rotation = -45,
		visible = false
	})

	self:_update_size_pos()
end

function TimerBarNote:_update_size_pos()
	self._button:set_size(self._panel:width() / 2, self._panel:width() / 2)
	self._mic:set_size(self._panel:width() * 0.8 * 49/107, self._panel:width() * 0.8)

	self._mic:set_center(self._panel:width() / 2, self._panel:height() / 2)
	self._button:set_center(self._panel:width() / 2, self._panel:height() / 2)
end

function TimerBarNote:hit()
	self._button:set_visible(false)
	self._mic:set_visible(true)
end

local size_update_methods = {
	"set_width",
	"set_shape",
	"set_height",
	"grow",
	"set_size"
}
for _, size_update_method_name in pairs(size_update_methods) do
	TimerBarNote[size_update_method_name] = function(self, ...)
		self._panel[size_update_method_name](self._panel, ...)

		self:_update_size_pos()
	end
end