KaraokeSplashGui = KaraokeSplashGui or class()

function KaraokeSplashGui:init(main_panel, data, x, y, w, h)
	if main_panel:child("karaoke_splash_panel") then
		main_panel:remove(main_panel:child("karaoke_splash_panel"))
	end

	self._karaoke_splash_panel = main_panel:panel({
		x = x,
		y = y,
		w = w,
		h = h,
		name = "karaoke_splash_panel",
		visible = true,
		layer = 0
	})

	self._splash_background = self._karaoke_splash_panel:rect({
		w = self._karaoke_splash_panel:width(),
		h = self._karaoke_splash_panel:height(),
		x = 0,
		y = 0,
		layer = 0,
		color = Color.black
	})

	self._karaoke_splash = self._karaoke_splash_panel:bitmap({
		layer = 1
	})
end

function KaraokeSplashGui:set_splash_texture(texture)
	self._karaoke_splash:set_image(texture)

	local splash_panel_width = self._karaoke_splash_panel:width()
	local splash_panel_height = self._karaoke_splash_panel:height()

	local splash_aspect = self._karaoke_splash:texture_width()/self._karaoke_splash:texture_height()
	local splash_panel_aspect = splash_panel_width/splash_panel_height

	local splash_width = splash_panel_width
	local splash_height = splash_panel_height

	if splash_aspect < splash_panel_aspect then
		splash_width = splash_panel_height * splash_aspect
	else
		splash_height = splash_panel_width / splash_aspect
	end

	self._karaoke_splash:set_size(splash_width, splash_height)
	self._karaoke_splash:set_center(splash_panel_width / 2, splash_panel_height / 2)
end

function KaraokeSplashGui:show()
	self._karaoke_splash_panel:set_visible(true)
end

function KaraokeSplashGui:hide()
	self._karaoke_splash_panel:set_visible(false)
end